package Game;

public class Cell {
	
	private int xLocation, yLocation;
	private int xDestination, yDestination;
	private int health, radius;
	public state currentState;
	public int speed;
	
	public Cell(){ //default constructor for new game i.e. newly gen'd cell
		this.health = 100;
		this.manageHealthIdentifiers();
	}
	
	public enum state{
		HEALTHY,
		ALRIGHT,
		SICK,
		CRITICAL
	}
	
	public void setDestination(int x, int y){
		//default will be singularity unless cell is selected
		this.xDestination = x;
		this.yDestination = y;
	}
	
	public void setCurrentLocation(int xLoc, int yLoc){
		this.xLocation = xLoc;
		this.yLocation = yLoc;
	}
	
	public int getCurrentXLocation(){
		return this.xLocation;
	}
	
	public int getCurrentYLocation(){
		return this.yLocation;
	}
	
	public void setSpeed(int speed){
		this.speed = speed;
	}
	
	public int getRadius(){
		return this.radius;
	}
	
	public void setHealth(int health){
		this.health = health;
		manageHealthIdentifiers();
	}
	
	public void manageHealthIdentifiers(){
		if(this.health <=10){
			this.currentState = state.CRITICAL;
			this.radius = 18/2;
			this.speed = 1;
		}
		else if(this.health <=25){
			this.currentState = state.SICK;
			this.radius = 24/2;
			this.speed = 1;
		}
		else if(this.health <=75){
			this.currentState = state.ALRIGHT;
			this.radius = 30/2;
			this.speed = 2;
		}
		else {
			this.currentState = state.HEALTHY;
			this.radius = 36/2;
			this.speed = 3;
		}
		
	}
	
}
