package Game;

import java.util.List;

import android.util.Log;
import Screens.LoadingScreen;
import Screens.Screen;
import Screens.StartScreen;
import com.example.cells.Graphics.Graphics;
import com.example.cells.IO.Touch;
import com.example.cells.IO.Touch.TouchEvent;


public class CellGame implements Game {
	//public Environment environment;
	private Touch touch;
	private Graphics graphics;
	Screen screen;
	private final String TAG = "CellGame implementation: ";
			
	public CellGame(Touch touch, Graphics graphics){
		this.screen = this.getLoadingScreen();
		//this.environment = new Environment();
		this.touch = touch;
		this.graphics = graphics;//canvas gets created within the Graphics obj
		
	}
	
	@Override
	public void setScreen(Screen screen) { //p.226
		if(screen == null){
			throw new IllegalArgumentException("Passed in Screen must not be null");
		}
	
		this.screen.pause();
		this.screen.dispose();	
		screen.resume();
		screen.update(0);
		this.screen = screen;	
	};
	
	@Override
	public  List<TouchEvent> getUserInput() {
		return touch.getTouchEvents();
	}
	
	@Override
	public void startGame(){};
	
	@Override
	public void pauseGame(){};
	
	@Override
	public void quitGame(){}

	@Override
	public Graphics getGraphics() {
		// TODO Auto-generated method stub
		return graphics;
	}

	@Override
	public Screen getLoadingScreen() {
		 return new LoadingScreen(this);
	}

	@Override
	public Screen getCurrentScreen() {
		if(screen == null){
			throw new IllegalArgumentException("Screen must not be null");
		}
		return this.screen;
	}

	

}
