package Screens;

import com.example.cells.Graphics.Graphics;

import Game.Assets;
import Game.Game;
import android.util.Log;

public class LoadingScreen extends Screen{
	private String TAG = "Loading Screen: ";
	
	public LoadingScreen(Game game){
		super(game);
		Log.d(TAG, "Constructor is called");
	}

	@Override
	public void update(float deltaTime) {
		Log.d(TAG, "Loading Screen UPDATE method called.");
		Graphics graphics = game.getGraphics();
		Log.d(TAG, "update() getGraphics call");
		Assets.startScreen = graphics.generateBitmap("cells/startScreen.png");
		Log.d(TAG, " update() Assets.startScreen set");
		Assets.loadingScreen = graphics.generateBitmap("cells/loadingScreen.png");
		Assets.environmentBackground = graphics.generateBitmap("cells/environmentBackground.png");
		Assets.cellCritical = graphics.generateBitmap("cells/cellCritical.png");
		Assets.cellHealthy = graphics.generateBitmap("cells/cellHealthy.png");
		Assets.cellHealthySelected = graphics.generateBitmap("cells/cellHealthySelected.png");
		game.setScreen(new StartScreen(game)); //always begin with start screen, with option to start new or load game
	}

	@Override
	public void present(float deltaTime) {
		//Graphics g = game.getGraphics();
		//g.drawBitmapHolder(Assets.loadingScreen, 0, 0);
		
	}

	@Override
	public void pause() {
		Log.d(TAG, " Useless PAUSE method call");
		
	}

	@Override
	public void resume() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void dispose() {
		Log.d(TAG, " Useless DISPOSE method call");
		
	}

}
