package com.example.cells.Graphics;
import android.graphics.Bitmap.Config;
import android.graphics.Bitmap;

/*
 * This is a setter for each Bitmap drawn to the canvas
 * each one of these is generated from the Graphics.java class
 * and is loaded onto the canvas as is needed for the game
 */
public class BitmapHolder {

	public Bitmap bitmap;
	public Config config;
	
	public BitmapHolder(Bitmap bitmap, android.graphics.Bitmap.Config config){
		this.bitmap = bitmap;
		this.config = config;
	}
	
	public int getWidth(){
		return bitmap.getWidth();
	}
	
	public int getHeight(){
		return bitmap.getHeight();
	}
	
	public Config getBitmapConfig(){
		return this.config;
	}
	
	public void dispose(){
		bitmap.recycle(); //gc'd
	}
}
