package com.example.cells.IO;

import java.util.List;

import android.content.Context;
import android.view.View;
import com.example.cells.IO.Handlers.*;
import com.example.cells.IO.Input.KeyEvent;
import com.example.cells.IO.Input.TouchEvent;
import java.util.List;

/**
 * This class is the coordinator for the entire game framework. This ties
 * together all the input handlers, and (for now) contains a multi-threaded
 * {@link SurfaceView} which contains the canvas and SKIA 2D drawing utilities.
 * In the future I would like to replace Google's SKIA 2D libraries and
 * implement OpenGL ES or Google's libgdx libraries.
 * (https://code.google.com/p/libgdx/)
 * 
 * @author meghan
 * 
 */
public class InputImpl implements Input {

	private KeyBoardHandler keyHandler;
	private TouchHandler touchHandler;

	public InputImpl(Context context, View view, float scaleX, float scaleY) {
		keyHandler = new KeyBoardHandler(view);
		touchHandler = new TouchHandler(view, scaleX, scaleY);
	}

	public boolean isKeyPressed(int keyCode) {
		// TODO Auto-generated method stub
		return keyHandler.isKeyPressed(keyCode);
	}

	public boolean isTouchDown(int pointer) {
		// TODO Auto-generated method stub
		return touchHandler.isTouched(pointer);
	}

	public int getTouchX(int pointer) {
		// TODO Auto-generated method stub
		return touchHandler.getTouchX(pointer);
	}

	public int getTouchY(int pointer) {
		// TODO Auto-generated method stub
		return touchHandler.getTouchY(pointer);
	}

	// dont have the accelerometer code yet. I have an old demo on the laptop
	public float getAccelX() {
		// TODO Auto-generated method stub
		return 0;
	}

	public float getAccelY() {
		// TODO Auto-generated method stub
		return 0;
	}

	public float getAccelZ() {
		// TODO Auto-generated method stub
		return 0;
	}

	public List<KeyEvent> getKeyEvents() {
		// TODO Auto-generated method stub
		return keyHandler.getKeyEvents();
	}

	public List<TouchEvent> getTouchEvents() {
		// TODO Auto-generated method stub
		return touchHandler.getTouchEvents();
	}

}
