package com.example.cells.IO;

import java.util.ArrayList;
import java.util.List;

public class Pool <T>{
	
	private final List<T> _poolOfObjects;
	private final ObjectFactory<T> _factory;
	private final int _max;
	
	public Pool(ObjectFactory<T> factory, int max){
		_factory = factory;
		_max = max;
		_poolOfObjects = new ArrayList<T>(max);
	}
	
	public T getObject(){
	
		T object = null;
		if (_poolOfObjects.size()==0){
			object = _factory.createObject();
		}else{
			object = _poolOfObjects.remove(_poolOfObjects.size()-1);
		}
		return object;
	}
	
	public void returnToPool(T object){
		if (_poolOfObjects.size() < _max){
			_poolOfObjects.add(object);
		}
	}
}
