package com.example.cells;

import com.example.cells.Views.GameSurfaceView;

import android.os.Bundle;
import android.app.Activity;
import android.graphics.Point;
import android.view.Display;
import android.view.Menu;
import android.view.Window;
import android.view.WindowManager;
import android.util.Log;
import android.graphics.Bitmap;
import android.graphics.Bitmap.Config;

public class MainActivity extends Activity {
	private GameSurfaceView view;
	private final String TAG = "THREAD 1";
	private StringBuilder builder = new StringBuilder();

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
	            WindowManager.LayoutParams.FLAG_FULLSCREEN);
		
		Display display = getWindowManager().getDefaultDisplay();
		@SuppressWarnings("deprecation")
		int width=display.getWidth();
		builder.append("Screen Width is: " +width+"\n");
		@SuppressWarnings("deprecation")
		int height=display.getHeight();
		builder.append("Screen Height is: " +height+"\n");
		Log.d(TAG, builder.toString());
		
		/*New API Upgrade Needed to 13
		Point size = new Point();
		display.getSize(size);
		if (size.x >= size.y) { //ensure horizontal
			int width = size.x;
			int height = size.y;
		}else{int width = size.y; int height=size.x;}*/
		
		Bitmap bitmap = Bitmap.createBitmap(width, height, Config.RGB_565);

		// setContentView(R.layout.activity_main);
		view = new GameSurfaceView(this, bitmap, width, height);
		setContentView(view);
		Log.d(TAG, "onCreate in the Activity");
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_main, menu);
		return true;
	}

	@Override
	public void onResume() {
		super.onResume();

	}

	@Override
	public void onPause() {
		super.onPause();
		view.surfaceViewStop();
	}

}
