package com.example.cells.Views;

import android.view.SurfaceHolder;
//import android.graphics.Canvas;
import android.graphics.Rect;
import Game.CellGame;
import Game.Game;
import android.util.Log;

/**
 * This is the rendering thread, rather than the IO thread, which is over on the GameSurfaceView, where user input is captured
 * @author meghan
 *
 *	Anything with Screens will occur in this thread, while game logic will occur in the other thread
 */
public class GameThread extends Thread{
	private SurfaceHolder myHolder;
	private GameSurfaceView gameSurfaceView;
	private Game game;
	private boolean running;
	private String TAG = "GAME_THREAD";
	
	public GameThread(GameSurfaceView passedSurfaceView, SurfaceHolder passedHolder, Game game){
		this.myHolder = passedHolder;
		this.gameSurfaceView = passedSurfaceView;
		this.game = game;
		Log.d(TAG, "GameThread Constructor");
	}
	
	public void setRun(boolean running){
		this.running = running;
	}
	
	public SurfaceHolder getSurfaceHolder(){
		return this.myHolder;
	}
	
	public void run(){
		final String TAGG = "THREAD 2";
		Log.d(TAGG, "GameThread run() call");
		
		Rect rect = new Rect();
		long startTime = System.nanoTime();
		
		while(this.running){
			//execute game loop
			this.gameSurfaceView.graphics.canvas = null;
			
			float deltaTime = (System.nanoTime() - startTime) / 1000000000.0f; //1 second, deltaTime => in seconds how much time has elapsed since startTime
			startTime = System.nanoTime();
			synchronized(myHolder){
			try {
				this.gameSurfaceView.graphics.canvas = myHolder.lockCanvas();
				game.getCurrentScreen().update(deltaTime);
				
				Log.d(TAGG, "LockCanvas called");
					if (this.gameSurfaceView.graphics.canvas != null) {
							game.getCurrentScreen().present(deltaTime); //chains to canvas.drawBitmap
							//gameSurfaceView.onDraw(this.gameSurfaceView.graphics.canvas);
							Log.d(TAGG, "Canvas width and hieght to be obtained - Height: " +this.gameSurfaceView.graphics.canvas.getHeight() + " Width:  " +this.gameSurfaceView.graphics.canvas.getWidth()   );
						
						Log.d(TAGG, "canvas is NOT null");
					} else if (this.gameSurfaceView.graphics.canvas == null) {
						Log.d(TAGG, "canvas is TOTALLY NULL ");
					}
			}// try
			finally {
				if(this.gameSurfaceView.graphics.canvas !=null){
					myHolder.unlockCanvasAndPost(this.gameSurfaceView.graphics.canvas);
					Log.d(TAGG, "after unlockAndPost");
				}
			}//finally
			}//synchronized	
		}//while(running)
	}//run
}
